<template>
  <div>
    <div @click="openDialog">
      <slot></slot>
    </div>
    <a-modal v-model="isDialogActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeDialog">
            Back
          </b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">Unit: {{ unit.name }}</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <a-radio-group v-model="tab" button-style="solid">
          <a-radio-button value="visual">Visual</a-radio-button>
          <a-radio-button value="daily">Daily Population Graph</a-radio-button>
          <a-radio-button value="checkin">Check-In Information</a-radio-button>
        </a-radio-group>
      </div>
      <div v-if="tab === 'visual'" class="p-12 py-10">
        <unit-visual></unit-visual>
      </div>
      <div v-if="tab === 'daily'" class="p-12 py-10">
        <unit-daily-population></unit-daily-population>
      </div>
      <div v-if="tab === 'checkin'" class="p-12 py-10">
        <unit-check-in></unit-check-in>
      </div>
    </a-modal>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import TH1 from '~/components/shared/typography/H1'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton'
import UnitCheckIn from '~/components/unit/UnitCheckIn.vue'
import UnitDailyPopulation from '~/components/unit/UnitDailyPopulation.vue'
import UnitVisual from '~/components/unit/UnitVisual.vue'
import { useBuilding } from '~/store/building'

export default defineComponent({
  components: {
    UnitCheckIn,
    UnitDailyPopulation,
    UnitVisual,
    BOutlineActionButton,
    TH1,
  },
  props: {
    unit: {
      type: Object,
      required: true
    }
  },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      tab: 'visual',
      isDialogActive: false,
    }
  },
  methods: {
    openDialog() {
      this.isDialogActive = true
      this.store.onSelectUnit(this.unit.id)
    },
    closeDialog() {
      this.isDialogActive = false
    },
  },
})
</script>
